///--------------------------------------------------------------------------------------
// Sprite data structures
///--------------------------------------------------------------------------------------

typedef struct SubStruct
{
	SpriteRec		subSprite;
	double			horizPos;
	double			vertPos;
	double			horizDelta;
	double			vertDelta;
	
	short			curDirection;
	short			numBulletsOnScreen;
	short			nextShotDelay;
	Boolean			canShoot;
} SubStruct, *SubStructPtr;


typedef struct BulletStruct
{
	SpriteRec		bulletSprite;
	SubStructPtr	parentStructP;		// pointer to the parent sub for this bullet
} BulletStruct, *BulletStructPtr;


typedef struct FishStruct
{
	SpriteRec		fishSprite;
	short			energy;			// When energy is 0, the fish is dead
	short			moveDelay;		// Stop fish if hit until moveDelay is up
	short			hitCounter;		// Set to > 0 when fish is hit, making it flash white
} FishStruct, *FishStructPtr;


typedef struct SharkStruct
{
	SpriteRec		sharkSprite;
	double			horizPos;
	double			vertPos;
	double			horizDelta;
	double			vertDelta;
	
	short			energy;			// When energy is 0, the shark is dead
	short			moveDelay;		// Slow fish down if hit until moveDelay is up
	short			hitCounter;		// Set to > 0 when fish is hit, making it flash white
} SharkStruct, *SharkStructPtr;



///--------------------------------------------------------------------------------------
// Defined values
///--------------------------------------------------------------------------------------


#define kLeftDirection			0
#define kRightDirection			1


///--------------------------------------------------------------------------------------
// Function prototypes
///--------------------------------------------------------------------------------------

void		LoadSprites( void );
void		DisposeSprites( void );
void		SetUpSprite(SpritePtr mySpriteP);

SpritePtr	NewSubSprite( void );
SpritePtr	NewBulletSprite( void );
SpritePtr	NewFishSprite( void );
SpritePtr	NewSharkSprite( void );
void		AddTitleSprite( void );
