///--------------------------------------------------------------------------------------
// Define various values
///--------------------------------------------------------------------------------------

enum soundIDs
{
	kShootBulletSnd,
	kHitFishSnd,
	kFishDeadSnd,
	kHitSharkSnd,
	kSharkDeadSnd,
	kSubDeadSnd,
	kNumSounds
};


#define	kLeftKeyPad				0x56
#define	kRightKeyPad			0x58
#define	kDownKeyPad				0x54
#define	kUpKeyPad				0x5B
#define kShootKeyPad			0x52

#define	kLeftArrowKey			0x7B
#define	kRightArrowKey			0x7C
#define	kDownArrowKey			0x7D
#define	kUpArrowKey				0x7E

#define kEscKey					0x35


typedef struct KeyStruct
{
	Boolean	left;
	Boolean	up;
	Boolean	right;
	Boolean	down;
	Boolean shoot;
	Boolean shift;
} KeyStruct;


///--------------------------------------------------------------------------------------
// Function prototypes
///--------------------------------------------------------------------------------------

void	SetUpSpriteWorld( void );

void	NewGame( void );
void	PrepareGame( void );
void	EraseMenuBar( void );
void	RunGame( void );
void	CleanUpAfterGame( void );

void	RemoveAllSprites(SpriteWorldPtr spriteWorldP);
void	PauseSprites(void);
void	UnpauseSprites(void);
short	CountNumSpritesOnScreen(SpriteWorldPtr spriteWorldP);

void	UpdateKeys( void );
void	ProcessKeyEvent( EventRecord *eventPtr );
void	PauseGame( void );
