///--------------------------------------------------------------------------------------
// Split-Screen Demo.h
//
// By: Vern Jensen
///--------------------------------------------------------------------------------------


#ifndef __WINDOWS__
#include <Windows.h>
#endif


#ifdef __cplusplus
extern "C" {
#endif


#define kTileWidth					32
#define kTileHeight					32

#define	kLeftPlayer1Key				0x01		// S
#define	kRightPlayer1Key			0x02		// D	  Q  E
#define	kDownPlayer1Key				0x07		// X		S D
#define	kUpPlayer1Key				0x0E		// E		 X
#define kShootPlayer1Key			0x0C		// Q

#define	kLeftKeyPad					0x56		// 4
#define	kRightKeyPad				0x58		// 6		 8
#define	kDownKeyPad					0x54		// 2		4 6
#define	kUpKeyPad					0x5B		// 8		 2
#define kShootKeyPad				0x52		// 0	   0


typedef struct KeyStruct
{
	Boolean	up;
	Boolean	right;
	Boolean	down;
	Boolean	left;
	Boolean shoot;
} KeyStruct;


enum tileIDs
{
	kFirstWallTile = 0,
	kLastWallTile = kFirstWallTile + 79,
	kFirstFloorTile,
	kMainFloorTile,
	kRockFloorTile,
	kMudTile,
	kFirstLavaTile,
	kLastLavaTile = kFirstLavaTile + 4,
	
	kMaxNumTiles
};

#define kWallDamageOffset	20


void	main( void );
void	CreateSpriteWorlds( void );
void	CreateTankSprites( void );
void	SetUpAnimation( void );

void	RunAnimation( void );
void	ShutDown( void );

SW_FUNC void TileChangeProc(SpriteWorldPtr spriteWorldP);

SW_FUNC void ScrollingWorldMoveProc(
	SpriteWorldPtr spriteWorldP,
	SpritePtr followSpriteP);

void	UpdateKeys( void );


#ifdef __cplusplus
}
#endif
