///--------------------------------------------------------------------------------------
// SpriteTest.h
///--------------------------------------------------------------------------------------
 

#ifndef __SPRITETEST__
#define __SPRITETEST__

#ifndef __MENUS__
#include <Menus.h>
#endif


enum
{
	kBaseResID = 128,
	kGlobeHeight = 48,
	kGlobeBorderWidth = 1,
	kNumberOfGlobeSprites = 4,
	kNumberOfGlobeFrames = 30,
	kGlobeSpriteMoveTime = 0,
	kGlobeSpriteFrameTime = 20,
	kTwoHeight = 50,
	kTwoBorderWidth = 1,
	kNumberOfTwoFrames = 10,
	kBackDropPixPatID = 128,
	kPerformanceAlertID = 200,
	kSetUpTestResID = 400,
	kTestTime = (30 * 60)
};

typedef enum
{ 
	kCopyBitsProc, 
	kBlitPixieProc, 
	kCompiledProc 
}ProcType;

enum
{
	kCopyBitsSpriteButton = 4,
	kBlitPixieSpriteButton,
	kCompiledSpriteButton,
	kCopyBitsOffscreenButton = 8,
	kBlitPixieOffscreenButton,
	kCopyBitsScreenButton = 11,
	kBlitPixieScreenButton,
	kRunTestNowCheckBox
};

typedef struct SpriteTestRec SpriteTestRec;
typedef SpriteTestRec *SpriteTestPtr, **SpriteTestHdl;


struct SpriteTestRec
{
	SpriteWorldPtr spriteWorldP;
	SpriteLayerPtr globeSpriteLayerP;
	SpritePtr globeSpriteArray[kNumberOfGlobeSprites];
	SpritePtr titleSpriteP;
	SpritePtr twoSpriteP;
};
		

OSErr SetupSWStuff(
	SpriteTestPtr* spriteTestP,
	CWindowPtr srcWindowP);

void DisposeSWStuff(
	SpriteTestPtr spriteTestP);

void SetupSpriteWorldElements(
	SpriteTestPtr spriteTestP);

void SetupGlobeSprite(
	SpritePtr testSpriteP,
	Rect *moveBoundsRect,
	short horizLocation,
	short vertLocation);

void SpriteTestIdle(
	SpriteTestPtr spriteTestP);

void UpdateSpriteTest(
	SpriteTestPtr spriteTestP,
	WindowPtr updateWindowP);

void HandleCreateSpriteCommand(
	SpriteTestPtr spriteTestP);

void HandleSpriteTestTitleCommand(
	SpriteTestPtr spriteTestP);

void HandleBouncingBallsCommand(
	SpriteTestPtr spriteTestP);

void RemoveClickedSprite(
	SpriteTestPtr spriteTestP);

void SetUpTestDialog(
	SpriteTestPtr spriteTestP);

void SetSetUpTestButtons(
	DialogPtr theDialog);
	
void RunTheTest(
	SpriteTestPtr spriteTestP);
	
void RestoreFromTest(
	WindowPtr testWindowP,
	SpriteTestPtr spriteTestP);
	
void DisplayPerformance(
	long frames,
	long seconds);
	
SW_FUNC void GlobeSpriteMoveProc(SpritePtr globeSpriteP);

SW_FUNC void PixelBounceCollideProc(
	SpritePtr srcSpriteP,
	SpritePtr dstSpriteP,
	Rect* sectRect);
	
SW_FUNC void RegionBounceCollideProc(
	SpritePtr srcSpriteP,
	SpritePtr dstSpriteP,
	Rect* sectRect);

SW_FUNC void RadiusBounceCollideProc(
	SpritePtr srcSpriteP,
	SpritePtr dstSpriteP,
	Rect* sectRect);

void BounceGlobeOffGlobe(
	SpritePtr srcSpriteP,
	SpritePtr dstSpriteP);

void BounceGlobeOffTitle(
	SpritePtr titleSpriteP,
	SpritePtr globeSpriteP,
	Rect* sectRect);
	

#endif	/* __SPRITETEST__ */