///--------------------------------------------------------------------------------------
//	Scrolling.h
//
//	By: Vern Jensen 8/29/95
///--------------------------------------------------------------------------------------


#ifndef __SCROLLING__
#define __SCROLLING__



///--------------------------------------------------------------------------------------
//	scrolling function prototypes
///--------------------------------------------------------------------------------------


#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif


SW_FUNC void SWUpdateScrollingWindow(
	SpriteWorldPtr spriteWorldP);

SW_FUNC void SWUpdateScrollingSpriteWorld(
	SpriteWorldPtr spriteWorldP,
	Boolean updateWindow);

SW_FUNC void SWProcessScrollingSpriteWorld(
	SpriteWorldPtr spriteWorldP);

SW_FUNC void SWAnimateScrollingSpriteWorld(
	SpriteWorldPtr spriteWorldP);

SW_FUNC void SWFastAnimateScrollingSpriteWorld(
	SpriteWorldPtr spriteWorldP);

SW_FUNC void SWDrawWrappedSprite(
	SpritePtr srcSpriteP,
	FramePtr dstFrameP,
	Rect* srcRect,
	Rect* dstRect);

SW_FUNC void SWEraseWrappedSprite(
	SpriteWorldPtr spriteWorldP,
	Rect* dstRect);

SW_FUNC void SWWrapWorldToScreen(
	SpriteWorldPtr	spriteWorldP);

SW_FUNC void SWWrapRectToScreen(
	SpriteWorldPtr	spriteWorldP,
	Rect			*srcRectP);

SW_FUNC void SWCheckWrappedIdleSpriteOverlap(
	SpriteWorldPtr			spriteWorldP,
	register SpritePtr		idleSpriteP,
	SpritePtr				headActiveSpriteP);

SW_FUNC void SWCheckWrappedIdleSpritesWithTiles(
	SpriteWorldPtr	spriteWorldP,
	SpritePtr		headIdleSpriteP);

SW_FUNC void SWCheckWrappedIdleSpritesWithRects(
	SpriteWorldPtr	spriteWorldP,
	SpritePtr		headIdleSpriteP);

SW_FUNC void SWSetScrollingWorldMoveBounds(
	SpriteWorldPtr	spriteWorldP,
	Rect* scrollRectMoveBounds);

SW_FUNC void SWSetScrollingWorldMoveProc(
	SpriteWorldPtr spriteWorldP, 
	WorldMoveProcPtr worldMoveProcP, 
	SpritePtr followSpriteP);

SW_FUNC void SWSetDoubleRectDrawProc(
	SpriteWorldPtr		spriteWorldP,
	DoubleDrawProcPtr	doubleRectDrawProc);

SW_FUNC void SWSetSpriteWorldScrollDelta(
	SpriteWorldPtr	spriteWorldP,
	short			horizDelta,
	short			vertDelta);

SW_FUNC void SWMoveVisScrollRect(
	SpriteWorldPtr	spriteWorldP,
	short			horizPos,
	short			vertPos);

SW_FUNC void SWOffsetVisScrollRect(
	SpriteWorldPtr	spriteWorldP,
	short			horizOffset,
	short			vertOffset);
	
SW_FUNC void SWResizeVisScrollRect(
	SpriteWorldPtr	spriteWorldP,
	short			horizSize,
	short			vertSize);

SW_FUNC void SWCalculateOffscreenScrollRect(
	SpriteWorldPtr spriteWorldP);


#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif

#ifdef __cplusplus
}
#endif

#endif /* __SCROLLING__ */