///--------------------------------------------------------------------------------------
//	BlitPixieScaled.h
//
//	Description: This is the include file for all the BlitPixie source files.
///--------------------------------------------------------------------------------------


#ifndef __BLITSCALEDPIXIE__
#define __BLITSCALEDPIXIE__

#ifndef __SWCOMMON__
#include "SWCommonHeaders.h"
#endif

#ifndef __SPRITEWORLDUTILS__
#include "SpriteWorldUtils.h"
#endif


#ifndef __BLITPIXIE__
#include "BlitPixie.h"
#endif


#ifdef __cplusplus
extern "C" {
#endif

///--------------------------------------------------------------------------------------
/// Public API
///--------------------------------------------------------------------------------------

SW_FUNC OSErr SWSetSpriteScaledSize(
	SpritePtr srcSpriteP,
	short width,
	short height);
	
SW_FUNC short SWGetSpriteScaledWidth(
	SpritePtr srcSpriteP);
	
SW_FUNC short SWGetSpriteScaledHeight(
	SpritePtr srcSpriteP);

///--------------------------------------------------------------------------------------
//	Function prototypes for 8-bit and 16-bit scaled blitters
///--------------------------------------------------------------------------------------

SW_FUNC void BlitPixie8BitScaledRectDrawProc(
	FramePtr srcFrameP,
	FramePtr dstFrameP,
	Rect *srcRect,
	Rect *dstRect);

SW_FUNC void BP8BitScaledSpriteRectDrawProc(
	FramePtr srcFrameP,
	FramePtr dstFrameP,
	Rect *srcRect,
	Rect *dstRect);

SW_FUNC void BP8BitScaledSpriteMaskDrawProc(
	FramePtr srcFrameP,
	FramePtr dstFrameP,
	Rect *srcRect,
	Rect *dstRect);

void BlitPixie8BitScaled(
	register unsigned char *srcPixelP,
	register unsigned char *dstPixelP,
	long srcRowsToCopy,
	long dstRowsToCopy,
	unsigned long srcOffset,
	unsigned long dstOffset,
	short leftClip,
	short topClip,
	short bottomClip,
	Boolean isBlittingToScreen);
	
void BlitPixieMask8BitScaled(
	register unsigned char *srcPixelP,
	register unsigned char *dstPixelP,
	register unsigned char *maskPixelP,
	long srcRowsToCopy,
	long dstRowsToCopy,
	unsigned long srcOffset,
	unsigned long dstOffset,
	short leftClip,
	short topClip,
	short bottomClip,
	short isBlittingToScreen);

void BlitScaledLine8Bit(
	register unsigned char *srcPixelP,
	register unsigned char *dstPixelP,
	Boolean weAreBlittingToScreen);

void BlitScaledMaskedLine8Bit(
	register unsigned char *srcPixelP,
	register unsigned char *maskPixelP,
	register unsigned char *dstPixelP,
	Boolean weAreBlittingToScreen);


//----------------------------------16 Bit Prototypes----------------------------------


SW_FUNC void BlitPixie16BitScaledRectDrawProc(
	FramePtr srcFrameP,
	FramePtr dstFrameP,
	Rect *srcRect,
	Rect *dstRect);

SW_FUNC void BP16BitScaledSpriteRectDrawProc(
	FramePtr srcFrameP,
	FramePtr dstFrameP,
	Rect *srcRect,
	Rect *dstRect);

SW_FUNC void BP16BitScaledSpriteMaskDrawProc(
	FramePtr srcFrameP,
	FramePtr dstFrameP,
	Rect *srcRect,
	Rect *dstRect);

void BlitPixie16BitScaled(
	unsigned short *srcPixelP,
	unsigned short *dstPixelP,
	register long srcRowsToCopy,
	register long dstRowsToCopy,
	register unsigned long srcOffset,
	register unsigned long dstOffset,
	short leftClip,
	short topClip,
	short bottomClip,
	short isBlittingToScreen);

void BlitPixieMask16BitScaled(
	unsigned short *srcPixelP,
	unsigned short *dstPixelP,
	unsigned short *maskPixelP,
	register long srcRowsToCopy,
	register long dstRowsToCopy,
	register unsigned long srcOffset,
	register unsigned long dstOffset,
	short leftClip,
	short topClip,
	short bottomClip);
	
void BlitScaledLine16Bit(
	register unsigned short *srcPixelP,
	register unsigned short *dstPixelP,
	Boolean weAreBlittingToScreen);

void BlitScaledMaskedLine16Bit(
	register unsigned short *srcPixelP,
	register unsigned short *maskPixelP,
	register unsigned short *dstPixelP);
	
void PrecomputeLookupTable(
	register long srcNumPixelsPerRow,
	register long dstNumPixelsPerRow,
	short leftClip,
	short rightClip);

#ifdef __cplusplus
}
#endif

#endif /* __BLITSCALEDPIXIE__ */
