///--------------------------------------------------------------------------------------
//	SWTranslucentBlitters.h
///--------------------------------------------------------------------------------------


#ifndef __LIGHTINGSQUARES__
#define __LIGHTINGSQUARES__

#ifndef __TRANSLUCENCY__
#include "SWTranslucentBlitters.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif
	
extern int SWLitSquareSize;
	
///--------------------------------------------------------------------------------------
///--------------------------------------------------------------------------------------
extern int gLightingSquareRows, gLightingSquareColumns;
extern unsigned long gBlackColor;

///--------------------------------------------------------------------------------------

SW_FUNC OSErr 	SWInitializeLightingSquares (SpriteWorldPtr spriteWorldP, 
											int squareSize);
SW_FUNC void 	SWExitLightingSquares(void);

SW_FUNC void SWSetLightingSquare(SpriteWorldPtr swp, int col, int row, 
						 unsigned long color, unsigned long level,
						 Boolean relative, Boolean makeDirty);
SW_FUNC void SWDarkenLightingSquares (SpriteWorldPtr swp);

SW_FUNC void SWLightUpArea (
	SpriteWorldPtr swp, 
	int col, 
	int row, 
	unsigned long lightColor, 
	int lightLevel, 
	Boolean BigLight);


///--------------------------------------------------------------------------------------

SW_FUNC void BlitPixie8BitLitRectDrawProc(
	FramePtr srcFrameP,
	FramePtr dstFrameP,
	Rect* srcRect,
	Rect* dstRect
	);

SW_FUNC unsigned char SWInline LightingConvertChar (
	register unsigned char srcPixel, 
	register unsigned char *tableAtLevelAndIndex);
SW_FUNC unsigned short  LightingConvertShort (
	register unsigned short srcPixel, 
	register unsigned char *tableAtLevelAndIndex);
SW_FUNC unsigned long  LightingConvertLong (
	register unsigned long srcPixel, 
	register unsigned char *tableAtLevelAndIndex);

SW_FUNC void BlitPixieLit8Bit(
	PixelChunkPtr srcPixelP,
	PixelChunkPtr dstPixelP,
	register unsigned long rowsToCopy,
	register unsigned long numBytesPerRow,
	register unsigned long srcOffset,
	register unsigned long dstOffset,
	register unsigned char *tableAtLevelAndIndex);

SW_FUNC void BlitPixie16BitLitRectDrawProc(
	FramePtr srcFrameP,
	FramePtr dstFrameP,
	Rect* srcRect,
	Rect* dstRect
	);

void BlitPixieLit16Bit(
	 unsigned short *srcPtr,
	 unsigned short *dstPtr,
	 unsigned long width,
	 unsigned long height,
	 unsigned long srcRowBytes,
	 unsigned long dstRowBytes,
	 unsigned long color,
	 unsigned long alpha);

#ifdef __cplusplus
}
#endif

#endif /* __LIGHTINGSQUARES__ */
