/*  -----------------------------------------------------------------------------------
	SWTinting.h
    ----------------------------------------------------------------------------------- */


SW_FUNC OSErr SWTintFrame(
	FramePtr srcFrameP,
	RGBColor* tint, 
	float percent);
	
// The number of Light Levels we define.  Universal constant because
// we encode light level in tileIDs, so all have to have the same.
#define kNumberOfBrightnessLevels 8
extern short backgroundTileMinimumLightLevel;
//  ---- The functions for doing tile light levels 
// For creating a set of tiles with different levels of darkness from a CICN
SW_FUNC OSErr CreateTileBrightnessSetFromCicnResource (
	SpriteWorldPtr	swp,
	short			baseTileID,
	short			cicnID, 
	MaskType		maskType);


SW_FUNC int GetTileBrightnessLevel (
	SpriteWorldPtr swp,
	short tileLayer,
	int row, 
	int col);
	
SW_FUNC void SetTileBrightnessLevel (
	SpriteWorldPtr swp, 
	short tileLayer,
	int row, 
	int col, 
	int level, 
	Boolean relative);

SW_FUNC void LowerTileBrightnessLevels (
	SpriteWorldPtr swp);

//  ---- The functions for doing sprite light levels 
SW_FUNC OSErr CreateSpriteBrightnessSetFromCicnResource (
	SpriteWorldPtr destSpriteWorld,
	SpritePtr* newSpriteP,
	void* spriteStorageP,
	short cIconID,
	MaskType maskType);

SW_FUNC int GetSpriteBrightnessLevel (SpritePtr spriteP);

SW_FUNC void SetSpriteBrightnessLevel (SpritePtr spriteP, int tileLightLevel);
