///--------------------------------------------------------------------------------------
//	Circular Scrolling.h
//
//	By: Vern Jensen 7/20/95
///--------------------------------------------------------------------------------------


#ifndef __CIRCULARSCROLLING__
#define __CIRCULARSCROLLING__



///--------------------------------------------------------------------------------------
//	circular scrolling function prototypes
///--------------------------------------------------------------------------------------


#ifdef __cplusplus
extern "C" {
#endif

SW_FUNC void SWUpdateCircularSpriteWorld(
	SpriteWorldPtr spriteWorldP);

SW_FUNC void SWProcessCircularSpriteWorld(
	SpriteWorldPtr spriteWorldP);

SW_FUNC void SWAnimateCircularSpriteWorld(
	SpriteWorldPtr spriteWorldP);

void SWDrawTilesInCircularScrollRect(
	SpriteWorldPtr	spriteWorldP);

void SWDrawTilesInWrappedRect(
	SpriteWorldPtr	spriteWorldP,
	Rect*			tempDstRectP,
	Boolean			optimizingMode);

void SWEraseSpritesInRect(
	SpriteWorldPtr	spriteWorldP,
	Rect*			updateRectP);

void SWDrawSpritesInRect(
	SpriteWorldPtr	spriteWorldP,
	Rect*			updateRectP);

void SWErasePieceOfSprite(
	SpriteWorldPtr	spriteWorldP,
	Rect*			updateRectP,
	Rect*			dstRectP);

void SWDrawPieceOfSprite(
	SpriteWorldPtr	spriteWorldP,
	Rect*			updateRectP,
	SpritePtr		curSpriteP,
	Rect*			srcRectP,
	Rect*			dstRectP);

SW_FUNC void SWMoveCircularVisScrollRect(
	SpriteWorldPtr	spriteWorldP,
	short			horizPos,
	short			vertPos);
	
SW_FUNC void SWOffsetCircularVisScrollRect(
	SpriteWorldPtr	spriteWorldP,
	short			horizOffset,
	short			vertOffset);

SW_FUNC void SWCollideCircularSpriteLayer(
	SpriteWorldPtr	spriteWorldP,
	SpriteLayerPtr srcSpriteLayerP,
	SpriteLayerPtr dstSpriteLayerP);

SW_FUNC void SWChangeCircularTileImage(
	SpriteWorldPtr	spriteWorldP,
	short			tileID,
	short			newImage);

SW_FUNC void SWUpdateCircularTileOnScreen(
	SpriteWorldPtr	spriteWorldP,
	short			tileID);

SW_FUNC OSErr SWDrawTilesInCircularBackground(
	SpriteWorldPtr	spriteWorldP);

SW_FUNC void SWDrawCircularTile(
	SpriteWorldPtr	spriteWorldP,
	short			dstTileLayer,
	short			tileRow,
	short			tileCol,
	short			tileID);


#ifdef __cplusplus
}
#endif

#endif /* __CIRCULARSCROLLING__ */