///--------------------------------------------------------------------------------------
//	SWApplication.h
//
//	Created:	Sunday, April 11, 1993
//	By:		Tony Myles. Extensive modifications by Vern Jensen and Karl Bunker.
//
//	Copyright:  1993 Tony Myles, All rights reserved worldwide.
///--------------------------------------------------------------------------------------


#ifndef __SWAPPLICATION__
#define __SWAPPLICATION__


#define kNumberOfMoreMastersCalls		3
#define kWindowResID					128

#define kErrorAlertResID				128
#define kCantRunAlertResID				129

#define kErrorStringListResID			128
#define kFatalErrorStringIndex			1
#define kCantFindResourceStringIndex	2
#define kOutOfMemoryStringIndex			3
#define kResNotFoundStringIndex			4

#define kSeriousDamageString "\pAn error has occurred, and the error string couldn't even be found!"

///--------------------------------------------------------------------------------------
// Macros for ReportIfError and CantFindResource
///--------------------------------------------------------------------------------------

#define FatalError(err)			if (err) ReportError(err, __FILE__, __LINE__);
#define CantFindResource()		DoCantFindResource(__FILE__, __LINE__);


///--------------------------------------------------------------------------------------
// Function prototypes
///--------------------------------------------------------------------------------------


#ifdef __cplusplus
extern "C" {
#endif


void	Initialize(short numberOfMasters);
void	SetCleanUpSpriteWorld(SpriteWorldPtr spriteWorldP);
void	ReportError(OSErr err, char* filename, int lineNumber);
void	DoCantFindResource(char* filename, int lineNumber);
void	ErrorAlert(OSErr err, char* filename, int lineNumber, short errorStringIndex);
void	CantRunOnThisMachine( void );


#ifdef __cplusplus
}
#endif


#endif /* __SWAPPLICATION__ */