///--------------------------------------------------------------------------------------
//	SWFastLine.h
///--------------------------------------------------------------------------------------

#ifndef __SWCOMMON__
#include "SWCommonHeaders.h"
#endif

#ifndef __TOOLUTILS__
#include <ToolUtils.h>
#endif

#ifndef __OSUTILS__
#include <OSUtils.h>
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

#ifndef __QDOFFSCREEN__
#include <QDOffscreen.h>
#endif

#ifndef __SPRITEWORLD__
#include "SpriteWorld.h"
#endif

#ifndef __SPRITEWORLDUTILS__
#include "SpriteWorldUtils.h"
#endif

#ifndef __SPRITEFRAME__
#include "SpriteFrame.h"
#endif

#ifndef __BLITPIXIE__
#include "BlitPixie.h"
#endif

#ifndef __SPRITECOMPILER__
#include "SpriteCompiler.h"
#endif


extern char 			gSWmmuMode;


#ifdef __cplusplus
extern "C" {
#endif

///--------------------------------------------------------------------------------------
//	Definitions
///--------------------------------------------------------------------------------------

typedef SW_FUNC void (*BlitLineProcPtr)(FramePtr dstFrameP, 
	Point srcPoint, Point dstPoint, Byte color);

typedef SW_FUNC void (*CopyLineProcPtr)(FramePtr srcFrameP, 
	FramePtr dstFrameP, Point srcPoint, Point dstPoint);


///--------------------------------------------------------------------------------------
//	Function prototypes
///--------------------------------------------------------------------------------------

SW_FUNC void SWDrawLine68kAsm(
	FramePtr dstFrameP, 
	Point srcPoint, 
	Point dstPoint, 
	Byte color);

SW_FUNC void SWDrawLine(
	FramePtr dstFrameP, 
	Point srcPoint, 
	Point dstPoint, 
	Byte color);

SW_FUNC void SWCopyLine(
	FramePtr srcFrameP, 
	FramePtr dstFrameP, 
	Point srcPoint, 
	Point dstPoint);

SW_FUNC void SWDrawFrameRect(
	FramePtr dstFrameP, 
	Rect *destRect, 
	Byte color);

SW_FUNC void SWCopyFrameRect(
	FramePtr srcFrameP, 
	FramePtr dstFrameP, 
	Rect *destRect);


SW_FUNC void SWDrawLineInScrollingWorld(
	SpriteWorldPtr spriteWorldP, 
	FramePtr dstFrameP, 
	Point srcPoint, 
	Point dstPoint, 
	Byte color);

SW_FUNC void SWCopyLineInScrollingWorld(
	SpriteWorldPtr spriteWorldP, 
	FramePtr srcFrameP, 
	FramePtr dstFrameP, 
	Point srcPoint, 
	Point dstPoint,
	Rect *clipRectP);

SW_FUNC void SWDrawFrameRectInScrollingWorld(
	SpriteWorldPtr spriteWorldP, 
	FramePtr dstFrameP, 
	Rect *dstRectP, 
	Byte color);

SW_FUNC void SWCopyFrameRectInScrollingWorld(
	SpriteWorldPtr spriteWorldP, 
	FramePtr srcFrameP, 
	FramePtr dstFrameP, 
	Rect *dstRectP,
	Rect *clipRectP);

///--------------------------------------------------------------------------------------
//	Internal functions
///--------------------------------------------------------------------------------------

SW_FUNC Boolean SWClipLineWithRect(Point *srcPoint, Point *dstPoint, Rect *clipRect);

void BlitLine68kAsm(
	Ptr baseAddr, 
	unsigned long rowBytes, 
	short x1,
	short x2, 
	short y1, 
	short y2, 
	unsigned char color);

SW_FUNC void BlitLine(
	FramePtr dstFrameP, 
	Point srcPoint, 
	Point dstPoint, 
	Byte color);

SW_FUNC void BPCopyLine(
	FramePtr srcFrameP,
	FramePtr dstFrameP, 
	Point srcPoint, 
	Point dstPoint);

SW_FUNC void BlitWrappingLine(
	FramePtr dstFrameP, 
	Point srcPoint, 
	Point dstPoint, 
	Byte color);
	
SW_FUNC void BPCopyWrappingLine(
	FramePtr srcFrameP, 
	FramePtr dstFrameP, 
	Point srcPoint, 
	Point dstPoint);


SW_FUNC void BlitStraightLine(
	FramePtr dstFrameP, 
	Point srcPoint, 
	Point dstPoint, 
	register Byte color);

SW_FUNC void BPCopyStraightLine(
	FramePtr srcFrameP, 
	FramePtr dstFrameP, 
	Point srcPoint, 
	Point dstPoint);
	
SW_FUNC void BlitStraightWrappingLine(
	FramePtr dstFrameP, 
	Point srcPoint, 
	Point dstPoint, 
	register Byte color);

SW_FUNC void BPCopyStraightWrappingLine(
	FramePtr srcFrameP, 
	FramePtr dstFrameP, 
	Point srcPoint, 
	Point dstPoint);

#ifdef __cplusplus
}
#endif