///--------------------------------------------------------------------------------------
// SWSounds.h
///--------------------------------------------------------------------------------------

#include "Sound.h"		// Include MacOS Sound header
#include "Sprite.h"		// Needs Sprite.h for GetStereoPositionOfSprite

#define k22khz		0x56EE8BA3

typedef enum
{
	kFindEmptyChannel = 1,
	kPlaySoundInChannel,
	kReplaceSameSound
} PlayType;


Boolean IsNewSoundManagerInstalled( void );
void	SetSystemVolume(short volume);
void	GetSystemVolume(short *volume);
void	SaveSystemVolume( void );
void	RestoreSystemVolume( void );
OSErr	CreateSoundChannels(short numChannels);
void	DisposeSoundChannels( void );
OSErr	LoadSounds( short startResID, short numSounds );
void	DisposeSounds( void );

void	PlaySound(
	short soundID, 
	short channelNum, 
	PlayType playType);

void	PlaySound2(
	short soundID, 
	short channelNum, 
	PlayType playType,
	short volume,
	short stereoPosition,
	UnsignedFixed rate,
	Boolean doLoopingSound);

short	FindChannel(short soundID, short channelNum, PlayType playType);

void	PlayMySound(short soundID, short channelNum);
void	StopSound(short soundID);
void	StopChannel(short channelNum);

void	SetChannelVolume(short channelNum, short newVolume);
void	SetStereoPosition(short channelNum, short stereoPosition);
void	SetVolumeAndStereoPosition(short channelNum, short newVolume, short stereoPosition);
void	SetChannelAvailability(short channelNum, Boolean isAvailable);
void	SetStereoMode(Boolean mode);
short	GetStereoPositionOfSprite(SpritePtr srcSpriteP, Rect *destRectP);
short	GetStereoPositionOfColumn(long col, Rect *backRectP);
short	FindSound(short soundID);

pascal void SoundCallBack(SndChannelPtr theChannel, SndCommand *theCommand);
